package kr.co.vividnext.sodalive.configs

import okhttp3.OkHttpClient
import org.springframework.context.annotation.Bean
import org.springframework.context.annotation.Configuration
import java.util.concurrent.TimeUnit

@Configuration
class OkHttpConfig {
    @Bean("okHttpClient")
    fun okHttpClient(): OkHttpClient {
        return OkHttpClient()
            .newBuilder().apply {
                // 서버 연결을 최대 60초 수행
                connectTimeout(60, TimeUnit.SECONDS)
                // 서버 요청을 최대 60초 수행
                writeTimeout(60, TimeUnit.SECONDS)
                // 서버 응답을 최대 60초 기다림
                readTimeout(60, TimeUnit.SECONDS)
            }.build()
    }
}
