package kr.co.vividnext.sodalive.member.stipulation

import kr.co.vividnext.sodalive.common.ApiResponse
import org.springframework.security.access.prepost.PreAuthorize
import org.springframework.web.bind.annotation.GetMapping
import org.springframework.web.bind.annotation.PostMapping
import org.springframework.web.bind.annotation.RequestBody
import org.springframework.web.bind.annotation.RequestMapping
import org.springframework.web.bind.annotation.RestController

@RestController
@RequestMapping("/stplat")
class StipulationController(private val service: StipulationService) {
    @PostMapping
    @PreAuthorize("hasRole('ADMIN')")
    fun enrollment(@RequestBody request: StipulationDto) = ApiResponse.ok(
        service.enrollment(request),
        "등록되었습니다."
    )

    @PostMapping("/modify")
    @PreAuthorize("hasRole('ADMIN')")
    fun modify(@RequestBody request: StipulationModifyRequest) = ApiResponse.ok(
        service.modify(request),
        "수정되었습니다."
    )

    @GetMapping("/terms_of_service")
    fun getTermsOfService() = ApiResponse.ok(service.getTermsOfService())

    @GetMapping("/privacy_policy")
    fun getPrivacyPolicy() = ApiResponse.ok(service.getPrivacyPolicy())
}
